> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/compute/bmc/bare-metal-instance/rebootinstances.md).

# RebootInstances

## 1. API Description

This API (RebootInstances) is used to restart instances.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">You can only perform this operation on instances whose status is</mark> <mark style="color:blue;">`STOPPED`</mark> <mark style="color:blue;">or</mark> <mark style="color:blue;">`RUNNING`</mark> <mark style="color:blue;">and that are not in the recycle bin.</mark>
* <mark style="color:blue;">If the API is called successfully, the instance status will become</mark> <mark style="color:blue;">`BOOTING`</mark><mark style="color:blue;">. After the instance is restarted, its status will become</mark> <mark style="color:blue;">`RUNNING`</mark> <mark style="color:blue;">again.</mark>
* <mark style="color:blue;">This API is an async API. A response is returned after the request is sent. However, it does not mean the restart has been completed. You can use</mark> [<mark style="color:purple;">DescribeInstances</mark>](/api-reference/compute/bmc/bare-metal-instance/describeinstances.md) <mark style="color:blue;">to query the status of the instance. If the status changes from</mark> <mark style="color:blue;">`BOOTING`</mark> <mark style="color:blue;">to</mark> <mark style="color:blue;">`RUNNING`</mark><mark style="color:blue;">, it means that the instance has been restarted successfully. Any operations on the instances are not allowed while creating.</mark>
* <mark style="color:blue;">Batch operations are supported. The maximum number of instances in each request is 100.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type            | Description                                                                                                                                                                              |
| -------------- | -------- | --------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| instanceIds    | Yes      | Array of String | <p>Instance ID(s).</p><p>To obtain the instance IDs, you can call DescribeInstances and look for instanceId in the response. The maximum number of instances in each request is 100.</p> |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Restart two instances.**

```json
POST /api/v2/bmc HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: RebootInstances
<Common Request Params>

Request:
{
  "instanceIds": [
    "instanceId1",
    "instanceId2"
  ]
}

Response:
{
  "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453",
  "response": {
    "requestId": "TC1748D3E-452D-4F74-8485-7AA73718E453"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                            | Description                                                 |
| ---------------- | ------------------------------------- | ----------------------------------------------------------- |
| 403              | OPERATION\_DENIED\_INSTANCE\_STATUS   | The current instance state does not support this operation. |
| 404              | INVALID\_INSTANCE\_NOT\_FOUND         | Instance does not exist.                                    |
| 403              | OPERATION\_DENIED\_INSTANCE\_RECYCLED | The instance is in the recycle bin.                         |
